/*
Copyright (c) 2014 DenshiKousakuSenka
 This software is released under the MIT License.
 http://opensource.org/licenses/mit-license.php
 */

#pragma once

#include "DKS_SPI_Base.h"
#include "DKS_GPIO_Base.h"

namespace DKS
{
	namespace L3GD20
	{
		enum PowerMode
		{
			PowerDown = 0x00,
			Active = 0x08
		};

		enum OutputDataRate
		{
			DataRate_1= 0x00,
			DataRate_2= 0x40,
			DataRate_3= 0x80,
			DataRate_4= 0xC0,
		};

		enum BandWidth
		{
			BandWidth_1	= 0x00,
			BandWidth_2	= 0x10,
			BandWidth_3	= 0x20,
			BandWidth_4	= 0x30,
		};

		enum FullScale
		{
			FullScale_250  = 0x00,
			FullScale_500  = 0x10,
			FullScale_2000 = 0x20,
		};

		class L3GD20
		{
			DKS::SPI::SPI_Base *m_spi;
			const DKS::IDigitalOut *m_ss;
			const PowerMode m_PowerMode;
			const OutputDataRate m_OutputDataRate;
			const BandWidth m_BandWidth;
			const FullScale m_FullScale;

			uint8_t SPI_Buffer[8];
			float sensitivity;

			void write(const uint8_t* pBuffer, const uint8_t &WriteAddr, const uint16_t &NumByteToWrite);
			void read(uint8_t* pBuffer,const uint8_t &ReadAddr,const uint16_t &NumByteToRead);

		public:
			L3GD20(DKS::SPI::SPI_Base *SPI, const DKS::IDigitalOut *SSpin);
			virtual ~L3GD20(){};
			void ReadMagData(float Data[3]);	//XYZ size=3
			void ReadMagData(uint16_t Data[3]);
			void ReadTemperature(int8_t &Temperature);
		};
	}
}
